/*
Green jump wire is connected to arduino GND (power)
Blue jump wire is connected to  arduinoGND
Yellow jump wire is connected to arduino A0 analog
Red jump wire is connected to arduino digital pin 9
*/

#define steps 128

float values1[steps];
float values2[steps];
float values3[steps];
/*float values4[steps];
float values5[steps];
float values6[steps];
float values7[steps];
float values8[steps];
*/
float alpha1;
float alpha2;
float alpha3;
/*float alpha4;
float alpha5;
float alpha6;
float alpha7;
float alpha8;
*/
int maxPos1, maxVal1;
int maxPos2, maxVal2;
int maxPos3, maxVal3;
/*int maxPos4, maxVal4;
int maxPos5, maxVal5;
int maxPos6, maxVal6;
int maxPos7, maxVal7;
int maxPos8, maxVal8;
*/
void setup ()
{
  pinMode (9, OUTPUT); 
  TCCR1A = 0;
  TCCR1B = 0;
  TCCR1A |= (1 << COM1A0);        // Toggle OC1A on Compare Match.
  TCCR1B |= (1 << WGM12);         // CTC mode 
  
  
  Serial.begin(57600);
}

void loop () {
  if (Serial.available()) {
    alpha1 = (float)Serial.read() / 255.0f;
    alpha2 = (float)Serial.read() / 255.0f;
    alpha3 = (float)Serial.read() / 255.0f;
    /*alpha4 = (float)Serial.read() / 255.0f;
    alpha5 = (float)Serial.read() / 255.0f;
    alpha6 = (float)Serial.read() / 255.0f;
    alpha7 = (float)Serial.read() / 255.0f;
    alpha8 = (float)Serial.read() / 255.0f;
  */
  }
 
  maxPos1 = 0;
  maxVal1 = 0;
  maxPos2 = 0;
  maxVal2 = 0;
  maxPos3 = 0;
  maxVal3 = 0;
  /*maxPos4 = 0;
  maxVal4 = 0;
  maxPos5 = 0;
  maxVal5 = 0;
  maxPos6 = 0;
  maxVal6 = 0;
  maxPos7 = 0;
  maxVal7 = 0;
  maxPos8 = 0;
  maxVal8 = 0;
*/
  
  for (int i= 0; i < steps; i++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = i;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal1 = analogRead(0);
    values1[i] = values1[i] * alpha1 + curVal1 * (1 - alpha1);  // exponential moving avg
    if (values1[i] > maxVal1) {                              // finds the signal peak
      maxVal1 = values1[i];
      maxPos1 = i;
    }
  }
  
  for (int j = 0; j < steps; j++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = j;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal2 = analogRead(1);
    values2[j] = values2[j] * alpha2 + curVal2 * (1 - alpha2);  // exponential moving avg
    if (values2[j] > maxVal2) {                              // finds the signal peak
      maxVal2 = values2[j];
      maxPos2 = j;
  
   }
  }
  
   for (int k = 0; k < steps; k++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = k;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal3 = analogRead(2);
    values3[k] = values3[k] * alpha3+ curVal3 * (1 - alpha3);  // exponential moving avg
    if (values3[k] > maxVal3) {                              // finds the signal peak
      maxVal3 = values3[k];
      maxPos3 = k;
    }
  }
  /*
   for (int l = 0; l < steps; l++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = l;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal4 = analogRead(3);
    values4[l] = values4[l] * alpha4+ curVal4 * (1 - alpha4);  // exponential moving avg
    if (values4[l] > maxVal4) {                              // finds the signal peak
      maxVal4 = values4[l];
      maxPos4 = l;
    }
  }
  
   for (int m = 0; m < steps; m++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = m;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal5 = analogRead(4);
    values5[m] = values5[m] * alpha5+ curVal5 * (1 - alpha5);  // exponential moving avg
    if (values5[m] > maxVal5) {                              // finds the signal peak
      maxVal5 = values5[m];
      maxPos5 = m;
    }
  }
  
   for (int n = 0; n < steps; n++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = n;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal6 = analogRead(5);
    values6[n] = values6[n] * alpha6+ curVal6 * (1 - alpha6);  // exponential moving avg
    if (values6[n] > maxVal6) {                              // finds the signal peak
      maxVal6 = values6[n];
      maxPos6 = n;
    }
  }
  
  for (int o = 0; o < steps; o++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = o;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal7 = analogRead(6);
    values7[o] = values7[o] * alpha7+ curVal7 * (1 - alpha7);  // exponential moving avg
    if (values7[o] > maxVal7) {                              // finds the signal peak
      maxVal7 = values7[o];
      maxPos7 = o;
    }
  }
  
  for (int p = 0; p < steps; p++) {
    TCCR1B &= 0xFE;                       // turns off timer
    TCNT1 = 0;                            // resets timer counter register
    OCR1A = p;                            // sets new frequency step
    TCCR1B |= 0x01;                       // turns on timer
    float curVal8 = analogRead(7);
    values8[p] = values8[p] * alpha8+ curVal8 * (1 - alpha8);  // exponential moving avg
    if (values8[p] > maxVal8) {                              // finds the signal peak
      maxVal8 = values8[p];
      maxPos8 = p;
    }
  } 
  
*/
  
  Serial.print(maxPos1, DEC);
  Serial.print(" ");
  Serial.print(maxVal1, DEC);
  Serial.print(" ");
  Serial.print(maxPos2, DEC);
  Serial.print(" "); 
  Serial.print(maxVal2, DEC);
  Serial.print(" ");
  Serial.print(maxPos3, DEC);
  Serial.print(" ");
  Serial.print(maxVal3, DEC);
  Serial.println(" ");
  /*Serial.print(maxPos4, DEC);
  Serial.print(" "); 
  Serial.print(maxVal4, DEC);
  Serial.print(" ");
  Serial.print(maxPos5, DEC);
  Serial.print(" "); 
  Serial.print(maxVal5, DEC);
  Serial.print(" ");
  Serial.print(maxPos6, DEC);
  Serial.print(" "); 
  Serial.print(maxVal6, DEC);
  Serial.print(" ");
  Serial.print(maxPos7, DEC);
  Serial.print(" "); 
  Serial.print(maxVal7, DEC);
  Serial.print(" ");
  Serial.print(maxPos8, DEC);
  Serial.print(" "); 
  Serial.print(maxVal8, DEC);
  Serial.print(" ");
*/
  }
  

